"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var LogicParser_exports = {};
__export(LogicParser_exports, {
  PeggySyntaxError: () => PeggySyntaxError,
  parse: () => parse
});
module.exports = __toCommonJS(LogicParser_exports);
const peggyParser = (
  // Generated by Peggy 3.0.2.
  //
  // https://peggyjs.org/
  // @ts-ignore
  function() {
    "use strict";
    function peg$subclass(child, parent) {
      function C() {
        this.constructor = child;
      }
      __name(C, "C");
      C.prototype = parent.prototype;
      child.prototype = new C();
    }
    __name(peg$subclass, "peg$subclass");
    function peg$SyntaxError(message, expected, found, location) {
      var self = Error.call(this, message);
      if (Object.setPrototypeOf) {
        Object.setPrototypeOf(self, peg$SyntaxError.prototype);
      }
      self.expected = expected;
      self.found = found;
      self.location = location;
      self.name = "SyntaxError";
      return self;
    }
    __name(peg$SyntaxError, "peg$SyntaxError");
    peg$subclass(peg$SyntaxError, Error);
    function peg$padEnd(str, targetLength, padString) {
      padString = padString || " ";
      if (str.length > targetLength)
        return str;
      targetLength -= str.length;
      padString += padString.repeat(targetLength);
      return str + padString.slice(0, targetLength);
    }
    __name(peg$padEnd, "peg$padEnd");
    peg$SyntaxError.prototype.format = function(sources) {
      var str = "Error: " + this.message;
      if (this.location) {
        var src = null;
        var k;
        for (k = 0; k < sources.length; k++) {
          if (sources[k].source === this.location.source) {
            src = sources[k].text.split(/\r\n|\n|\r/g);
            break;
          }
        }
        var s = this.location.start;
        var offset_s = this.location.source && typeof this.location.source.offset === "function" ? this.location.source.offset(s) : s;
        var loc = this.location.source + ":" + offset_s.line + ":" + offset_s.column;
        if (src) {
          var e = this.location.end;
          var filler = peg$padEnd("", offset_s.line.toString().length, " ");
          var line = src[s.line - 1];
          var last = s.line === e.line ? e.column : line.length + 1;
          var hatLen = last - s.column || 1;
          str += "\n --> " + loc + "\n" + filler + " |\n" + offset_s.line + " | " + line + "\n" + filler + " | " + peg$padEnd("", s.column - 1, " ") + peg$padEnd("", hatLen, "^");
        } else {
          str += "\n at " + loc;
        }
      }
      return str;
    };
    peg$SyntaxError.buildMessage = function(expected, found) {
      var DESCRIBE_EXPECTATION_FNS = {
        // @ts-ignore
        literal: /* @__PURE__ */ __name(function(expectation) {
          return '"' + literalEscape(expectation.text) + '"';
        }, "literal"),
        // @ts-ignore
        class: /* @__PURE__ */ __name(function(expectation) {
          var escapedParts = expectation.parts.map(function(part) {
            return Array.isArray(part) ? classEscape(part[0]) + "-" + classEscape(part[1]) : classEscape(part);
          });
          return "[" + (expectation.inverted ? "^" : "") + escapedParts.join("") + "]";
        }, "class"),
        // @ts-ignore
        any: /* @__PURE__ */ __name(function() {
          return "any character";
        }, "any"),
        // @ts-ignore
        end: /* @__PURE__ */ __name(function() {
          return "end of input";
        }, "end"),
        // @ts-ignore
        other: /* @__PURE__ */ __name(function(expectation) {
          return expectation.description;
        }, "other")
      };
      function hex(ch) {
        return ch.charCodeAt(0).toString(16).toUpperCase();
      }
      __name(hex, "hex");
      function literalEscape(s) {
        return s.replace(/\\/g, "\\\\").replace(/"/g, '\\"').replace(/\0/g, "\\0").replace(/\t/g, "\\t").replace(/\n/g, "\\n").replace(/\r/g, "\\r").replace(/[\x00-\x0F]/g, function(ch) {
          return "\\x0" + hex(ch);
        }).replace(/[\x10-\x1F\x7F-\x9F]/g, function(ch) {
          return "\\x" + hex(ch);
        });
      }
      __name(literalEscape, "literalEscape");
      function classEscape(s) {
        return s.replace(/\\/g, "\\\\").replace(/\]/g, "\\]").replace(/\^/g, "\\^").replace(/-/g, "\\-").replace(/\0/g, "\\0").replace(/\t/g, "\\t").replace(/\n/g, "\\n").replace(/\r/g, "\\r").replace(/[\x00-\x0F]/g, function(ch) {
          return "\\x0" + hex(ch);
        }).replace(/[\x10-\x1F\x7F-\x9F]/g, function(ch) {
          return "\\x" + hex(ch);
        });
      }
      __name(classEscape, "classEscape");
      function describeExpectation(expectation) {
        return DESCRIBE_EXPECTATION_FNS[expectation.type](expectation);
      }
      __name(describeExpectation, "describeExpectation");
      function describeExpected(expected2) {
        var descriptions = expected2.map(describeExpectation);
        var i, j;
        descriptions.sort();
        if (descriptions.length > 0) {
          for (i = 1, j = 1; i < descriptions.length; i++) {
            if (descriptions[i - 1] !== descriptions[i]) {
              descriptions[j] = descriptions[i];
              j++;
            }
          }
          descriptions.length = j;
        }
        switch (descriptions.length) {
          // @ts-ignore
          case 1:
            return descriptions[0];
          // @ts-ignore
          case 2:
            return descriptions[0] + " or " + descriptions[1];
          // @ts-ignore
          default:
            return descriptions.slice(0, -1).join(", ") + ", or " + descriptions[descriptions.length - 1];
        }
      }
      __name(describeExpected, "describeExpected");
      function describeFound(found2) {
        return found2 ? '"' + literalEscape(found2) + '"' : "end of input";
      }
      __name(describeFound, "describeFound");
      return "Expected " + describeExpected(expected) + " but " + describeFound(found) + " found.";
    };
    function peg$parse(input, options) {
      options = options !== void 0 ? options : {};
      var peg$FAILED = {};
      var peg$source = options.grammarSource;
      var peg$startRuleFunctions = { start: peg$parsestart };
      var peg$startRuleFunction = peg$parsestart;
      var peg$c0 = "(";
      var peg$c1 = ")";
      var peg$c2 = "||";
      var peg$c3 = "&&";
      var peg$c4 = ">=";
      var peg$c5 = ">";
      var peg$c6 = "<=";
      var peg$c7 = "<";
      var peg$c8 = "===";
      var peg$c9 = "-";
      var peg$c10 = "0x";
      var peg$c11 = ".";
      var peg$c12 = '"';
      var peg$c13 = "'";
      var peg$r0 = /^[a-zA-Z]/;
      var peg$r1 = /^[a-zA-Z0-9]/;
      var peg$r2 = /^[0-9]/;
      var peg$r3 = /^[0-9a-f]/i;
      var peg$r4 = /^[^"]/;
      var peg$r5 = /^[^']/;
      var peg$r6 = /^[ \t\n\r]/;
      var peg$e0 = peg$otherExpectation("grouped expression");
      var peg$e1 = peg$literalExpectation("(", false);
      var peg$e2 = peg$literalExpectation(")", false);
      var peg$e3 = peg$otherExpectation("logical OR");
      var peg$e4 = peg$literalExpectation("||", false);
      var peg$e5 = peg$otherExpectation("logical AND");
      var peg$e6 = peg$literalExpectation("&&", false);
      var peg$e7 = peg$otherExpectation("numeric comparison");
      var peg$e8 = peg$literalExpectation(">=", false);
      var peg$e9 = peg$literalExpectation(">", false);
      var peg$e10 = peg$literalExpectation("<=", false);
      var peg$e11 = peg$literalExpectation("<", false);
      var peg$e12 = peg$literalExpectation("===", false);
      var peg$e13 = peg$otherExpectation("version comparison");
      var peg$e14 = peg$otherExpectation("variable");
      var peg$e15 = peg$classExpectation([["a", "z"], ["A", "Z"]], false, false);
      var peg$e16 = peg$classExpectation([["a", "z"], ["A", "Z"], ["0", "9"]], false, false);
      var peg$e17 = peg$otherExpectation("number");
      var peg$e18 = peg$literalExpectation("-", false);
      var peg$e19 = peg$classExpectation([["0", "9"]], false, false);
      var peg$e20 = peg$otherExpectation("hex number");
      var peg$e21 = peg$literalExpectation("0x", false);
      var peg$e22 = peg$classExpectation([["0", "9"], ["a", "f"]], false, true);
      var peg$e23 = peg$otherExpectation("version string");
      var peg$e24 = peg$literalExpectation(".", false);
      var peg$e25 = peg$otherExpectation("string");
      var peg$e26 = peg$literalExpectation('"', false);
      var peg$e27 = peg$classExpectation(['"'], true, false);
      var peg$e28 = peg$literalExpectation("'", false);
      var peg$e29 = peg$classExpectation(["'"], true, false);
      var peg$e30 = peg$otherExpectation("whitespace");
      var peg$e31 = peg$classExpectation([" ", "	", "\n", "\r"], false, false);
      var peg$f0 = /* @__PURE__ */ __name(function(group) {
        return group;
      }, "peg$f0");
      var peg$f1 = /* @__PURE__ */ __name(function(head, tails) {
        return { or: [head, ...tails] };
      }, "peg$f1");
      var peg$f2 = /* @__PURE__ */ __name(function(tail) {
        return tail;
      }, "peg$f2");
      var peg$f3 = /* @__PURE__ */ __name(function(head, tails) {
        return { and: [head, ...tails] };
      }, "peg$f3");
      var peg$f4 = /* @__PURE__ */ __name(function(tail) {
        return tail;
      }, "peg$f4");
      var peg$f5 = /* @__PURE__ */ __name(function(head, expr, tail) {
        return { [expr]: [head, tail] };
      }, "peg$f5");
      var peg$f6 = /* @__PURE__ */ __name(function(head, expr, tail) {
        return { ["ver " + expr]: [head, tail] };
      }, "peg$f6");
      var peg$f7 = /* @__PURE__ */ __name(function(variable) {
        return { var: variable[1].join("") };
      }, "peg$f7");
      var peg$f8 = /* @__PURE__ */ __name(function() {
        return parseInt(text(), 10);
      }, "peg$f8");
      var peg$f9 = /* @__PURE__ */ __name(function() {
        return parseInt(text(), 16);
      }, "peg$f9");
      var peg$f10 = /* @__PURE__ */ __name(function(version) {
        return text();
      }, "peg$f10");
      var peg$f11 = /* @__PURE__ */ __name(function() {
        return text();
      }, "peg$f11");
      var peg$f12 = /* @__PURE__ */ __name(function() {
        return text();
      }, "peg$f12");
      var peg$currPos = 0;
      var peg$savedPos = 0;
      var peg$posDetailsCache = [{ line: 1, column: 1 }];
      var peg$maxFailPos = 0;
      var peg$maxFailExpected = [];
      var peg$silentFails = 0;
      var peg$result;
      if ("startRule" in options) {
        if (!(options.startRule in peg$startRuleFunctions)) {
          throw new Error(`Can't start parsing from rule "` + options.startRule + '".');
        }
        peg$startRuleFunction = peg$startRuleFunctions[options.startRule];
      }
      function text() {
        return input.substring(peg$savedPos, peg$currPos);
      }
      __name(text, "text");
      function offset() {
        return peg$savedPos;
      }
      __name(offset, "offset");
      function range() {
        return {
          // @ts-ignore
          source: peg$source,
          // @ts-ignore
          start: peg$savedPos,
          // @ts-ignore
          end: peg$currPos
        };
      }
      __name(range, "range");
      function location() {
        return peg$computeLocation(peg$savedPos, peg$currPos);
      }
      __name(location, "location");
      function expected(description, location2) {
        location2 = location2 !== void 0 ? location2 : peg$computeLocation(peg$savedPos, peg$currPos);
        throw peg$buildStructuredError(
          // @ts-ignore
          [peg$otherExpectation(description)],
          // @ts-ignore
          input.substring(peg$savedPos, peg$currPos),
          // @ts-ignore
          location2
        );
      }
      __name(expected, "expected");
      function error(message, location2) {
        location2 = location2 !== void 0 ? location2 : peg$computeLocation(peg$savedPos, peg$currPos);
        throw peg$buildSimpleError(message, location2);
      }
      __name(error, "error");
      function peg$literalExpectation(text2, ignoreCase) {
        return { type: "literal", text: text2, ignoreCase };
      }
      __name(peg$literalExpectation, "peg$literalExpectation");
      function peg$classExpectation(parts, inverted, ignoreCase) {
        return {
          type: "class",
          parts,
          inverted,
          ignoreCase
        };
      }
      __name(peg$classExpectation, "peg$classExpectation");
      function peg$anyExpectation() {
        return { type: "any" };
      }
      __name(peg$anyExpectation, "peg$anyExpectation");
      function peg$endExpectation() {
        return { type: "end" };
      }
      __name(peg$endExpectation, "peg$endExpectation");
      function peg$otherExpectation(description) {
        return { type: "other", description };
      }
      __name(peg$otherExpectation, "peg$otherExpectation");
      function peg$computePosDetails(pos) {
        var details = peg$posDetailsCache[pos];
        var p;
        if (details) {
          return details;
        } else {
          p = pos - 1;
          while (!peg$posDetailsCache[p]) {
            p--;
          }
          details = peg$posDetailsCache[p];
          details = {
            // @ts-ignore
            line: details.line,
            // @ts-ignore
            column: details.column
          };
          while (p < pos) {
            if (input.charCodeAt(p) === 10) {
              details.line++;
              details.column = 1;
            } else {
              details.column++;
            }
            p++;
          }
          peg$posDetailsCache[pos] = details;
          return details;
        }
      }
      __name(peg$computePosDetails, "peg$computePosDetails");
      function peg$computeLocation(startPos, endPos, offset2) {
        var startPosDetails = peg$computePosDetails(startPos);
        var endPosDetails = peg$computePosDetails(endPos);
        var res = {
          // @ts-ignore
          source: peg$source,
          // @ts-ignore
          start: {
            // @ts-ignore
            offset: startPos,
            // @ts-ignore
            line: startPosDetails.line,
            // @ts-ignore
            column: startPosDetails.column
          },
          // @ts-ignore
          end: {
            // @ts-ignore
            offset: endPos,
            // @ts-ignore
            line: endPosDetails.line,
            // @ts-ignore
            column: endPosDetails.column
          }
        };
        if (offset2 && peg$source && typeof peg$source.offset === "function") {
          res.start = peg$source.offset(res.start);
          res.end = peg$source.offset(res.end);
        }
        return res;
      }
      __name(peg$computeLocation, "peg$computeLocation");
      function peg$fail(expected2) {
        if (peg$currPos < peg$maxFailPos)
          return;
        if (peg$currPos > peg$maxFailPos) {
          peg$maxFailPos = peg$currPos;
          peg$maxFailExpected = [];
        }
        peg$maxFailExpected.push(expected2);
      }
      __name(peg$fail, "peg$fail");
      function peg$buildSimpleError(message, location2) {
        return new peg$SyntaxError(message, null, null, location2);
      }
      __name(peg$buildSimpleError, "peg$buildSimpleError");
      function peg$buildStructuredError(expected2, found, location2) {
        return new peg$SyntaxError(
          // @ts-ignore
          peg$SyntaxError.buildMessage(expected2, found),
          // @ts-ignore
          expected2,
          // @ts-ignore
          found,
          // @ts-ignore
          location2
        );
      }
      __name(peg$buildStructuredError, "peg$buildStructuredError");
      function peg$parsestart() {
        var s0;
        s0 = peg$parsegroup();
        if (s0 === peg$FAILED) {
          s0 = peg$parseor();
          if (s0 === peg$FAILED) {
            s0 = peg$parseand();
            if (s0 === peg$FAILED) {
              s0 = peg$parsecomparison();
            }
          }
        }
        return s0;
      }
      __name(peg$parsestart, "peg$parsestart");
      function peg$parsegroup() {
        var s0, s1, s2, s3, s4, s5, s6;
        peg$silentFails++;
        s0 = peg$currPos;
        s1 = peg$parse_();
        if (input.charCodeAt(peg$currPos) === 40) {
          s2 = peg$c0;
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0)
            peg$fail(peg$e1);
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          s4 = peg$parseor();
          if (s4 !== peg$FAILED) {
            s5 = peg$parse_();
            if (input.charCodeAt(peg$currPos) === 41) {
              s6 = peg$c1;
              peg$currPos++;
            } else {
              s6 = peg$FAILED;
              if (peg$silentFails === 0)
                peg$fail(peg$e2);
            }
            if (s6 !== peg$FAILED) {
              peg$savedPos = s0;
              s0 = peg$f0(s4);
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        peg$silentFails--;
        if (s0 === peg$FAILED) {
          s1 = peg$FAILED;
          if (peg$silentFails === 0)
            peg$fail(peg$e0);
        }
        return s0;
      }
      __name(peg$parsegroup, "peg$parsegroup");
      function peg$parseor() {
        var s0, s1, s2, s3, s4;
        peg$silentFails++;
        s0 = peg$currPos;
        s1 = peg$parse_();
        s2 = peg$parseand();
        if (s2 === peg$FAILED) {
          s2 = peg$parsecomparison();
        }
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$parseor_tails();
          if (s4 !== peg$FAILED) {
            while (s4 !== peg$FAILED) {
              s3.push(s4);
              s4 = peg$parseor_tails();
            }
          } else {
            s3 = peg$FAILED;
          }
          if (s3 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f1(s2, s3);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        peg$silentFails--;
        if (s0 === peg$FAILED) {
          s1 = peg$FAILED;
          if (peg$silentFails === 0)
            peg$fail(peg$e3);
        }
        return s0;
      }
      __name(peg$parseor, "peg$parseor");
      function peg$parseor_tails() {
        var s0, s1, s2, s3, s4;
        s0 = peg$currPos;
        s1 = peg$parse_();
        if (input.substr(peg$currPos, 2) === peg$c2) {
          s2 = peg$c2;
          peg$currPos += 2;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0)
            peg$fail(peg$e4);
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          s4 = peg$parseand();
          if (s4 === peg$FAILED) {
            s4 = peg$parsecomparison();
          }
          if (s4 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f2(s4);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      __name(peg$parseor_tails, "peg$parseor_tails");
      function peg$parseand() {
        var s0, s1, s2, s3, s4;
        peg$silentFails++;
        s0 = peg$currPos;
        s1 = peg$parse_();
        s2 = peg$parsegroup();
        if (s2 === peg$FAILED) {
          s2 = peg$parsecomparison();
        }
        if (s2 !== peg$FAILED) {
          s3 = [];
          s4 = peg$parseand_tails();
          if (s4 !== peg$FAILED) {
            while (s4 !== peg$FAILED) {
              s3.push(s4);
              s4 = peg$parseand_tails();
            }
          } else {
            s3 = peg$FAILED;
          }
          if (s3 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f3(s2, s3);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        peg$silentFails--;
        if (s0 === peg$FAILED) {
          s1 = peg$FAILED;
          if (peg$silentFails === 0)
            peg$fail(peg$e5);
        }
        return s0;
      }
      __name(peg$parseand, "peg$parseand");
      function peg$parseand_tails() {
        var s0, s1, s2, s3, s4;
        s0 = peg$currPos;
        s1 = peg$parse_();
        if (input.substr(peg$currPos, 2) === peg$c3) {
          s2 = peg$c3;
          peg$currPos += 2;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0)
            peg$fail(peg$e6);
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          s4 = peg$parsegroup();
          if (s4 === peg$FAILED) {
            s4 = peg$parsecomparison();
          }
          if (s4 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f4(s4);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        return s0;
      }
      __name(peg$parseand_tails, "peg$parseand_tails");
      function peg$parsecomparison() {
        var s0;
        s0 = peg$parsever_comparison();
        if (s0 === peg$FAILED) {
          s0 = peg$parseint_comparison();
        }
        return s0;
      }
      __name(peg$parsecomparison, "peg$parsecomparison");
      function peg$parseint_comparison() {
        var s0, s1, s2, s3, s4, s5, s6, s7;
        peg$silentFails++;
        s0 = peg$currPos;
        s1 = peg$parse_();
        s2 = peg$parseterm();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (input.substr(peg$currPos, 2) === peg$c4) {
            s4 = peg$c4;
            peg$currPos += 2;
          } else {
            s4 = peg$FAILED;
            if (peg$silentFails === 0)
              peg$fail(peg$e8);
          }
          if (s4 === peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 62) {
              s4 = peg$c5;
              peg$currPos++;
            } else {
              s4 = peg$FAILED;
              if (peg$silentFails === 0)
                peg$fail(peg$e9);
            }
            if (s4 === peg$FAILED) {
              if (input.substr(peg$currPos, 2) === peg$c6) {
                s4 = peg$c6;
                peg$currPos += 2;
              } else {
                s4 = peg$FAILED;
                if (peg$silentFails === 0)
                  peg$fail(peg$e10);
              }
              if (s4 === peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 60) {
                  s4 = peg$c7;
                  peg$currPos++;
                } else {
                  s4 = peg$FAILED;
                  if (peg$silentFails === 0) {
                    peg$fail(peg$e11);
                  }
                }
                if (s4 === peg$FAILED) {
                  if (input.substr(peg$currPos, 3) === peg$c8) {
                    s4 = peg$c8;
                    peg$currPos += 3;
                  } else {
                    s4 = peg$FAILED;
                    if (peg$silentFails === 0) {
                      peg$fail(peg$e12);
                    }
                  }
                }
              }
            }
          }
          if (s4 !== peg$FAILED) {
            s5 = peg$parse_();
            s6 = peg$parseterm();
            if (s6 !== peg$FAILED) {
              s7 = peg$parse_();
              peg$savedPos = s0;
              s0 = peg$f5(s2, s4, s6);
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        peg$silentFails--;
        if (s0 === peg$FAILED) {
          s1 = peg$FAILED;
          if (peg$silentFails === 0)
            peg$fail(peg$e7);
        }
        return s0;
      }
      __name(peg$parseint_comparison, "peg$parseint_comparison");
      function peg$parsever_comparison() {
        var s0, s1, s2, s3, s4, s5, s6, s7;
        peg$silentFails++;
        s0 = peg$currPos;
        s1 = peg$parse_();
        s2 = peg$parseterm();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          if (input.substr(peg$currPos, 2) === peg$c4) {
            s4 = peg$c4;
            peg$currPos += 2;
          } else {
            s4 = peg$FAILED;
            if (peg$silentFails === 0)
              peg$fail(peg$e8);
          }
          if (s4 === peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 62) {
              s4 = peg$c5;
              peg$currPos++;
            } else {
              s4 = peg$FAILED;
              if (peg$silentFails === 0)
                peg$fail(peg$e9);
            }
            if (s4 === peg$FAILED) {
              if (input.substr(peg$currPos, 2) === peg$c6) {
                s4 = peg$c6;
                peg$currPos += 2;
              } else {
                s4 = peg$FAILED;
                if (peg$silentFails === 0)
                  peg$fail(peg$e10);
              }
              if (s4 === peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 60) {
                  s4 = peg$c7;
                  peg$currPos++;
                } else {
                  s4 = peg$FAILED;
                  if (peg$silentFails === 0) {
                    peg$fail(peg$e11);
                  }
                }
                if (s4 === peg$FAILED) {
                  if (input.substr(peg$currPos, 3) === peg$c8) {
                    s4 = peg$c8;
                    peg$currPos += 3;
                  } else {
                    s4 = peg$FAILED;
                    if (peg$silentFails === 0) {
                      peg$fail(peg$e12);
                    }
                  }
                }
              }
            }
          }
          if (s4 !== peg$FAILED) {
            s5 = peg$parse_();
            s6 = peg$parseversion();
            if (s6 !== peg$FAILED) {
              s7 = peg$parse_();
              peg$savedPos = s0;
              s0 = peg$f6(s2, s4, s6);
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        peg$silentFails--;
        if (s0 === peg$FAILED) {
          s1 = peg$FAILED;
          if (peg$silentFails === 0)
            peg$fail(peg$e13);
        }
        return s0;
      }
      __name(peg$parsever_comparison, "peg$parsever_comparison");
      function peg$parseterm() {
        var s0;
        s0 = peg$parseconst();
        if (s0 === peg$FAILED) {
          s0 = peg$parsestring();
          if (s0 === peg$FAILED) {
            s0 = peg$parsehex();
            if (s0 === peg$FAILED) {
              s0 = peg$parseinteger();
            }
          }
        }
        return s0;
      }
      __name(peg$parseterm, "peg$parseterm");
      function peg$parseconst() {
        var s0, s1, s2, s3, s4, s5;
        peg$silentFails++;
        s0 = peg$currPos;
        s1 = peg$parse_();
        s2 = peg$currPos;
        s3 = peg$currPos;
        peg$silentFails++;
        if (peg$r0.test(input.charAt(peg$currPos))) {
          s4 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s4 = peg$FAILED;
          if (peg$silentFails === 0)
            peg$fail(peg$e15);
        }
        peg$silentFails--;
        if (s4 !== peg$FAILED) {
          peg$currPos = s3;
          s3 = void 0;
        } else {
          s3 = peg$FAILED;
        }
        if (s3 !== peg$FAILED) {
          s4 = [];
          if (peg$r1.test(input.charAt(peg$currPos))) {
            s5 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
            if (peg$silentFails === 0)
              peg$fail(peg$e16);
          }
          if (s5 !== peg$FAILED) {
            while (s5 !== peg$FAILED) {
              s4.push(s5);
              if (peg$r1.test(input.charAt(peg$currPos))) {
                s5 = input.charAt(peg$currPos);
                peg$currPos++;
              } else {
                s5 = peg$FAILED;
                if (peg$silentFails === 0)
                  peg$fail(peg$e16);
              }
            }
          } else {
            s4 = peg$FAILED;
          }
          if (s4 !== peg$FAILED) {
            s3 = [s3, s4];
            s2 = s3;
          } else {
            peg$currPos = s2;
            s2 = peg$FAILED;
          }
        } else {
          peg$currPos = s2;
          s2 = peg$FAILED;
        }
        if (s2 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f7(s2);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        peg$silentFails--;
        if (s0 === peg$FAILED) {
          s1 = peg$FAILED;
          if (peg$silentFails === 0)
            peg$fail(peg$e14);
        }
        return s0;
      }
      __name(peg$parseconst, "peg$parseconst");
      function peg$parseinteger() {
        var s0, s1, s2, s3, s4, s5;
        peg$silentFails++;
        s0 = peg$currPos;
        s1 = peg$parse_();
        s2 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 45) {
          s3 = peg$c9;
          peg$currPos++;
        } else {
          s3 = peg$FAILED;
          if (peg$silentFails === 0)
            peg$fail(peg$e18);
        }
        if (s3 === peg$FAILED) {
          s3 = null;
        }
        s4 = [];
        if (peg$r2.test(input.charAt(peg$currPos))) {
          s5 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s5 = peg$FAILED;
          if (peg$silentFails === 0)
            peg$fail(peg$e19);
        }
        if (s5 !== peg$FAILED) {
          while (s5 !== peg$FAILED) {
            s4.push(s5);
            if (peg$r2.test(input.charAt(peg$currPos))) {
              s5 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s5 = peg$FAILED;
              if (peg$silentFails === 0)
                peg$fail(peg$e19);
            }
          }
        } else {
          s4 = peg$FAILED;
        }
        if (s4 !== peg$FAILED) {
          s3 = [s3, s4];
          s2 = s3;
        } else {
          peg$currPos = s2;
          s2 = peg$FAILED;
        }
        if (s2 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f8();
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        peg$silentFails--;
        if (s0 === peg$FAILED) {
          s1 = peg$FAILED;
          if (peg$silentFails === 0)
            peg$fail(peg$e17);
        }
        return s0;
      }
      __name(peg$parseinteger, "peg$parseinteger");
      function peg$parsehex() {
        var s0, s1, s2, s3, s4, s5;
        peg$silentFails++;
        s0 = peg$currPos;
        s1 = peg$parse_();
        s2 = peg$currPos;
        if (input.substr(peg$currPos, 2) === peg$c10) {
          s3 = peg$c10;
          peg$currPos += 2;
        } else {
          s3 = peg$FAILED;
          if (peg$silentFails === 0)
            peg$fail(peg$e21);
        }
        if (s3 !== peg$FAILED) {
          s4 = [];
          if (peg$r3.test(input.charAt(peg$currPos))) {
            s5 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
            if (peg$silentFails === 0)
              peg$fail(peg$e22);
          }
          if (s5 !== peg$FAILED) {
            while (s5 !== peg$FAILED) {
              s4.push(s5);
              if (peg$r3.test(input.charAt(peg$currPos))) {
                s5 = input.charAt(peg$currPos);
                peg$currPos++;
              } else {
                s5 = peg$FAILED;
                if (peg$silentFails === 0)
                  peg$fail(peg$e22);
              }
            }
          } else {
            s4 = peg$FAILED;
          }
          if (s4 !== peg$FAILED) {
            s3 = [s3, s4];
            s2 = s3;
          } else {
            peg$currPos = s2;
            s2 = peg$FAILED;
          }
        } else {
          peg$currPos = s2;
          s2 = peg$FAILED;
        }
        if (s2 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f9();
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        peg$silentFails--;
        if (s0 === peg$FAILED) {
          s1 = peg$FAILED;
          if (peg$silentFails === 0)
            peg$fail(peg$e20);
        }
        return s0;
      }
      __name(peg$parsehex, "peg$parsehex");
      function peg$parseversion() {
        var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;
        peg$silentFails++;
        s0 = peg$currPos;
        s1 = peg$parse_();
        s2 = peg$currPos;
        s3 = [];
        if (peg$r2.test(input.charAt(peg$currPos))) {
          s4 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s4 = peg$FAILED;
          if (peg$silentFails === 0)
            peg$fail(peg$e19);
        }
        if (s4 !== peg$FAILED) {
          while (s4 !== peg$FAILED) {
            s3.push(s4);
            if (peg$r2.test(input.charAt(peg$currPos))) {
              s4 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s4 = peg$FAILED;
              if (peg$silentFails === 0)
                peg$fail(peg$e19);
            }
          }
        } else {
          s3 = peg$FAILED;
        }
        if (s3 !== peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 46) {
            s4 = peg$c11;
            peg$currPos++;
          } else {
            s4 = peg$FAILED;
            if (peg$silentFails === 0)
              peg$fail(peg$e24);
          }
          if (s4 !== peg$FAILED) {
            s5 = [];
            if (peg$r2.test(input.charAt(peg$currPos))) {
              s6 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s6 = peg$FAILED;
              if (peg$silentFails === 0)
                peg$fail(peg$e19);
            }
            if (s6 !== peg$FAILED) {
              while (s6 !== peg$FAILED) {
                s5.push(s6);
                if (peg$r2.test(input.charAt(peg$currPos))) {
                  s6 = input.charAt(peg$currPos);
                  peg$currPos++;
                } else {
                  s6 = peg$FAILED;
                  if (peg$silentFails === 0) {
                    peg$fail(peg$e19);
                  }
                }
              }
            } else {
              s5 = peg$FAILED;
            }
            if (s5 !== peg$FAILED) {
              s6 = peg$currPos;
              if (input.charCodeAt(peg$currPos) === 46) {
                s7 = peg$c11;
                peg$currPos++;
              } else {
                s7 = peg$FAILED;
                if (peg$silentFails === 0)
                  peg$fail(peg$e24);
              }
              if (s7 !== peg$FAILED) {
                s8 = [];
                if (peg$r2.test(input.charAt(peg$currPos))) {
                  s9 = input.charAt(peg$currPos);
                  peg$currPos++;
                } else {
                  s9 = peg$FAILED;
                  if (peg$silentFails === 0) {
                    peg$fail(peg$e19);
                  }
                }
                if (s9 !== peg$FAILED) {
                  while (s9 !== peg$FAILED) {
                    s8.push(s9);
                    if (peg$r2.test(input.charAt(peg$currPos))) {
                      s9 = input.charAt(peg$currPos);
                      peg$currPos++;
                    } else {
                      s9 = peg$FAILED;
                      if (peg$silentFails === 0) {
                        peg$fail(peg$e19);
                      }
                    }
                  }
                } else {
                  s8 = peg$FAILED;
                }
                if (s8 !== peg$FAILED) {
                  s7 = [s7, s8];
                  s6 = s7;
                } else {
                  peg$currPos = s6;
                  s6 = peg$FAILED;
                }
              } else {
                peg$currPos = s6;
                s6 = peg$FAILED;
              }
              if (s6 === peg$FAILED) {
                s6 = null;
              }
              s3 = [s3, s4, s5, s6];
              s2 = s3;
            } else {
              peg$currPos = s2;
              s2 = peg$FAILED;
            }
          } else {
            peg$currPos = s2;
            s2 = peg$FAILED;
          }
        } else {
          peg$currPos = s2;
          s2 = peg$FAILED;
        }
        if (s2 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f10(s2);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        peg$silentFails--;
        if (s0 === peg$FAILED) {
          s1 = peg$FAILED;
          if (peg$silentFails === 0)
            peg$fail(peg$e23);
        }
        return s0;
      }
      __name(peg$parseversion, "peg$parseversion");
      function peg$parsestring() {
        var s0, s1, s2, s3, s4, s5;
        peg$silentFails++;
        s0 = peg$currPos;
        s1 = peg$parse_();
        s2 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 34) {
          s3 = peg$c12;
          peg$currPos++;
        } else {
          s3 = peg$FAILED;
          if (peg$silentFails === 0)
            peg$fail(peg$e26);
        }
        if (s3 !== peg$FAILED) {
          s4 = [];
          if (peg$r4.test(input.charAt(peg$currPos))) {
            s5 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
            if (peg$silentFails === 0)
              peg$fail(peg$e27);
          }
          while (s5 !== peg$FAILED) {
            s4.push(s5);
            if (peg$r4.test(input.charAt(peg$currPos))) {
              s5 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s5 = peg$FAILED;
              if (peg$silentFails === 0)
                peg$fail(peg$e27);
            }
          }
          if (input.charCodeAt(peg$currPos) === 34) {
            s5 = peg$c12;
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
            if (peg$silentFails === 0)
              peg$fail(peg$e26);
          }
          if (s5 !== peg$FAILED) {
            s3 = [s3, s4, s5];
            s2 = s3;
          } else {
            peg$currPos = s2;
            s2 = peg$FAILED;
          }
        } else {
          peg$currPos = s2;
          s2 = peg$FAILED;
        }
        if (s2 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f11();
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$parse_();
          s2 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 39) {
            s3 = peg$c13;
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0)
              peg$fail(peg$e28);
          }
          if (s3 !== peg$FAILED) {
            s4 = [];
            if (peg$r5.test(input.charAt(peg$currPos))) {
              s5 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s5 = peg$FAILED;
              if (peg$silentFails === 0)
                peg$fail(peg$e29);
            }
            while (s5 !== peg$FAILED) {
              s4.push(s5);
              if (peg$r5.test(input.charAt(peg$currPos))) {
                s5 = input.charAt(peg$currPos);
                peg$currPos++;
              } else {
                s5 = peg$FAILED;
                if (peg$silentFails === 0)
                  peg$fail(peg$e29);
              }
            }
            if (input.charCodeAt(peg$currPos) === 39) {
              s5 = peg$c13;
              peg$currPos++;
            } else {
              s5 = peg$FAILED;
              if (peg$silentFails === 0)
                peg$fail(peg$e28);
            }
            if (s5 !== peg$FAILED) {
              s3 = [s3, s4, s5];
              s2 = s3;
            } else {
              peg$currPos = s2;
              s2 = peg$FAILED;
            }
          } else {
            peg$currPos = s2;
            s2 = peg$FAILED;
          }
          if (s2 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f12();
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        }
        peg$silentFails--;
        if (s0 === peg$FAILED) {
          s1 = peg$FAILED;
          if (peg$silentFails === 0)
            peg$fail(peg$e25);
        }
        return s0;
      }
      __name(peg$parsestring, "peg$parsestring");
      function peg$parse_() {
        var s0, s1;
        peg$silentFails++;
        s0 = [];
        if (peg$r6.test(input.charAt(peg$currPos))) {
          s1 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s1 = peg$FAILED;
          if (peg$silentFails === 0)
            peg$fail(peg$e31);
        }
        while (s1 !== peg$FAILED) {
          s0.push(s1);
          if (peg$r6.test(input.charAt(peg$currPos))) {
            s1 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0)
              peg$fail(peg$e31);
          }
        }
        peg$silentFails--;
        s1 = peg$FAILED;
        if (peg$silentFails === 0)
          peg$fail(peg$e30);
        return s0;
      }
      __name(peg$parse_, "peg$parse_");
      peg$result = peg$startRuleFunction();
      if (peg$result !== peg$FAILED && peg$currPos === input.length) {
        return peg$result;
      } else {
        if (peg$result !== peg$FAILED && peg$currPos < input.length) {
          peg$fail(peg$endExpectation());
        }
        throw peg$buildStructuredError(
          // @ts-ignore
          peg$maxFailExpected,
          // @ts-ignore
          peg$maxFailPos < input.length ? input.charAt(peg$maxFailPos) : null,
          // @ts-ignore
          peg$maxFailPos < input.length ? peg$computeLocation(peg$maxFailPos, peg$maxFailPos + 1) : peg$computeLocation(peg$maxFailPos, peg$maxFailPos)
        );
      }
    }
    __name(peg$parse, "peg$parse");
    return {
      SyntaxError: peg$SyntaxError,
      parse: peg$parse
    };
  }()
);
peggyParser.SyntaxError.prototype.name = "PeggySyntaxError";
const parse = peggyParser.parse;
const PeggySyntaxError = peggyParser.SyntaxError;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  PeggySyntaxError,
  parse
});
//# sourceMappingURL=LogicParser.js.map
